﻿Public Class Sum
    Inherits FunctionBase

    Private fValue1 As Double
    Private fValue2 As Double
    Private fValue3 As Double
    Private fValue4 As Double


    Public Overrides Function Evaluate(ByVal x As Double, ByVal y As Double) As Double
        Return fValue1 + fValue2 + fValue3 + fValue4
    End Function

    Public Overrides ReadOnly Property Name As String
        Get
            Return "Sum"
        End Get
    End Property

    Public Overrides ReadOnly Property Help As String
        Get
            Return "Gibt die Summe aller Value Werte aus."
        End Get
    End Property

    Public Overrides ReadOnly Property Type As FunctionType
        Get
            Return FunctionType.Function
        End Get
    End Property


    Public Overrides ReadOnly Property ParameterInfos As System.Data.DataTable
        Get
            Dim tbl As New DataTable
            tbl.Columns.Add("Index", GetType(Int32))
            tbl.Columns.Add("Name", GetType(String))
            tbl.Columns.Add("Step", GetType(Double))
            tbl.Columns.Add("Default", GetType(Double))
            tbl.Columns.Add("Current", GetType(Double))
            tbl.Rows.Add(0, "Value1", 0.1, 0, fValue1)
            tbl.Rows.Add(1, "Value2", 0.1, 0, fValue2)
            tbl.Rows.Add(2, "Value3", 0.1, 0, fValue3)
            tbl.Rows.Add(3, "Value4", 0.1, 0, fValue4)
            Return tbl
        End Get
    End Property


    Public Overrides Sub SetParameterValue(ByVal Index As Integer, ByVal Value As Double)
        Select Case Index
            Case 0
                fValue1 = Value
            Case 1
                fValue2 = Value
            Case 2
                fValue3 = Value
            Case 3
                fValue4 = Value
        End Select
    End Sub

    Public Overrides Sub AddParameterValue(Index As Integer, Value As Double)
        Select Case Index
            Case 0
                fValue1 += Value
            Case 1
                fValue2 += Value
            Case 2
                fValue3 += Value
            Case 3
                fValue4 += Value
        End Select
    End Sub
End Class
