﻿Public Class frmEnterValue

    Public IsValid As Boolean = False
    Public Value As Double

    Private fDefault As Double

    Public Sub Display(ByVal Instance As ConfigInstance, ByVal ParameterIndex As Int32)
        Dim tbl As DataTable = Instance.[Function].ParameterInfos
        lblDesc.Text = "Neuer Wert für " & CStr(tbl.Rows(ParameterIndex)("Name")) & ":"
        Value = CDbl(tbl.Rows(ParameterIndex)("Current"))
        fDefault = CDbl(tbl.Rows(ParameterIndex)("Default"))
        txtValue.Text = Value.ToString("N3")
        IsValid = False
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If Not Double.TryParse(txtValue.Text, Value) Then
            MessageBox.Show("Kein gültiger Wert!")
            Exit Sub
        End If
        IsValid = True
        Me.Hide()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Value = fDefault
        IsValid = True
        Me.Hide()
    End Sub
End Class